
/*
 *                            COPYRIGHT
 *
 *  XAnalyser, frequence spectrum analyser for X Windows
 *  Copyright (C) 1998 Arvin Schnell
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Contact addresses:
 *  aschnell@physik.uni-bremen.de or arvinschnell@yahoo.com
 *  Arvin Schnell, Am Heidberg 8, 28865 Lilienthal, Germany
 *
 */


#include <stdio.h>
#include <iostream.h>
#include <math.h>

#include <X11/Xlib.h>
#include <Xm/Xm.h>
#include <Xm/Scale.h>



void
myXGetDrawableSize( Display *display, Drawable drawable,
		    unsigned int *width, unsigned int *height )
{
  Window root;
  int x, y;
  unsigned int border, depth;
  
  XGetGeometry( display, drawable, &root, &x, &y,
		width, height, &border, &depth );
}



double
myXmScaleGetValue( Widget widget )
{
  int value;
  short int point;
  Arg args[] = {
    { XmNvalue, (XtArgVal) &value },
    { XmNdecimalPoints, (XtArgVal) &point }
  };
  XtGetValues( widget, args, XtNumber( args ) );
  
  double base = pow( 10.0, point );
  return value / base;
}



void
myXmScaleSetValue( Widget widget, double value )
{
  short int point;
  Arg args[] = {
    { XmNdecimalPoints, (XtArgVal) &point }
  };
  XtGetValues( widget, args, XtNumber( args ) );
  
  double base = pow( 10.0, point );
  XmScaleSetValue( widget, (int)( value * base ) );
}

